diff --git a/gdb/breakpoint.c b/gdb/breakpoint.c
index 2c901ff..8a47adc 100644
--- a/gdb/breakpoint.c
+++ b/gdb/breakpoint.c
@@ -9678,7 +9678,7 @@ create_breakpoint (struct gdbarch *gdbarch,
           /* If pending breakpoint support is auto query and the user
 	     selects no, then simply return the error code.  */
 	  if (pending_break_support == AUTO_BOOLEAN_AUTO
-	      && !nquery (_("Make %s pending on future shared library load? "),
+	      && !nquery (_("Make %s pending on future shared library load?"),
 			  bptype_string (type_wanted)))
 	    return 0;
 
@@ -13868,7 +13868,7 @@ delete_command (char *arg, int from_tty)
 
       /* Ask user only if there are some breakpoints to delete.  */
       if (!from_tty
-	  || (breaks_to_delete && query (_("Delete all breakpoints? "))))
+	  || (breaks_to_delete && query (_("Delete all breakpoints?"))))
 	{
 	  ALL_BREAKPOINTS_SAFE (b, b_tmp)
 	    if (user_breakpoint_p (b))
@@ -15307,7 +15307,7 @@ delete_trace_command (char *arg, int from_tty)
 
       /* Ask user only if there are some breakpoints to delete.  */
       if (!from_tty
-	  || (breaks_to_delete && query (_("Delete all tracepoints? "))))
+	  || (breaks_to_delete && query (_("Delete all tracepoints?"))))
 	{
 	  ALL_BREAKPOINTS_SAFE (b, b_tmp)
 	    if (is_tracepoint (b) && user_breakpoint_p (b))
diff --git a/gdb/cli/cli-script.c b/gdb/cli/cli-script.c
index 4d35db9..bf13a7e 100644
--- a/gdb/cli/cli-script.c
+++ b/gdb/cli/cli-script.c
@@ -1525,9 +1525,9 @@ define_command (char *comname, int from_tty)
       int q;
 
       if (c->theclass == class_user || c->theclass == class_alias)
-	q = query (_("Redefine command \"%s\"? "), c->name);
+	q = query (_("Redefine command \"%s\"?"), c->name);
       else
-	q = query (_("Really redefine built-in command \"%s\"? "), c->name);
+	q = query (_("Really redefine built-in command \"%s\"?"), c->name);
       if (!q)
 	error (_("Command \"%s\" not redefined."), c->name);
     }
@@ -1559,7 +1559,7 @@ define_command (char *comname, int from_tty)
 	  warning (_("Your new `%s' command does not "
 		     "hook any existing command."),
 		   comfull);
-	  if (!query (_("Proceed? ")))
+	  if (!query (_("Proceed?")))
 	    error (_("Not confirmed."));
 	}
     }
diff --git a/gdb/exec.c b/gdb/exec.c
index 3089bb4..a5fe98e 100644
--- a/gdb/exec.c
+++ b/gdb/exec.c
@@ -353,7 +353,7 @@ exec_file_command (char *args, int from_tty)
 
   if (from_tty && target_has_execution
       && !query (_("A program is being debugged already.\n"
-		   "Are you sure you want to change the file? ")))
+		   "Are you sure you want to change the file?")))
     error (_("File not changed."));
 
   if (args)
diff --git a/gdb/gnu-nat.c b/gdb/gnu-nat.c
index d3f54d0..fd52b79 100644
--- a/gdb/gnu-nat.c
+++ b/gdb/gnu-nat.c
@@ -856,7 +856,7 @@ inf_validate_task_sc (struct inf *inf)
 
       target_terminal_ours ();	/* Allow I/O.  */
       abort = !query (_("Pid %d has an additional task suspend count of %d;"
-		      " clear it? "), inf->pid,
+		      " clear it?"), inf->pid,
 		      suspend_count - inf->task->cur_sc);
       target_terminal_inferior ();	/* Give it back to the child.  */
 
diff --git a/gdb/infcmd.c b/gdb/infcmd.c
index 54aa1ef..eb5add2 100644
--- a/gdb/infcmd.c
+++ b/gdb/infcmd.c
@@ -487,7 +487,7 @@ kill_if_already_running (int from_tty)
 
       if (from_tty
 	  && !query (_("The program being debugged has been started already.\n\
-Start it from the beginning? ")))
+Start it from the beginning?")))
 	error (_("Program not restarted."));
       target_kill ();
     }
@@ -1207,7 +1207,7 @@ jump_command (char *arg, int from_tty)
   sfn = find_pc_function (sal.pc);
   if (fn != NULL && sfn != fn)
     {
-      if (!query (_("Line %d is not in `%s'.  Jump anyway? "), sal.line,
+      if (!query (_("Line %d is not in `%s'.  Jump anyway?"), sal.line,
 		  SYMBOL_PRINT_NAME (fn)))
 	{
 	  error (_("Not confirmed."));
@@ -1225,7 +1225,7 @@ jump_command (char *arg, int from_tty)
 	  && !section_is_mapped (section))
 	{
 	  if (!query (_("WARNING!!!  Destination is in "
-			"unmapped overlay!  Jump anyway? ")))
+			"unmapped overlay!  Jump anyway?")))
 	    {
 	      error (_("Not confirmed."));
 	      /* NOTREACHED */
@@ -1327,7 +1327,7 @@ signal_command (char *signum_exp, int from_tty)
       if (must_confirm
 	  && !query (_("Continuing thread %d (the current thread) with specified signal will\n"
 		       "still deliver the signals noted above to their respective threads.\n"
-		       "Continue anyway? "),
+		       "Continue anyway?"),
 		     inferior_thread ()->num))
 	error (_("Not confirmed."));
     }
@@ -2020,7 +2020,7 @@ finish_command (char *arg, int from_tty)
 	{
 	  if (sm->function != NULL && TYPE_NO_RETURN (sm->function->type)
 	      && !query (_("warning: Function %s does not return normally.\n"
-			   "Try to finish anyway? "),
+			   "Try to finish anyway?"),
 			 SYMBOL_PRINT_NAME (sm->function)))
 	    error (_("Not confirmed."));
 	  printf_filtered (_("Run till exit from "));
@@ -2206,7 +2206,7 @@ unset_environment_command (char *var, int from_tty)
     {
       /* If there is no argument, delete all environment variables.
          Ask for confirmation if reading from the terminal.  */
-      if (!from_tty || query (_("Delete all environment variables? ")))
+      if (!from_tty || query (_("Delete all environment variables?")))
 	{
 	  free_environ (current_inferior ()->environment);
 	  current_inferior ()->environment = make_environ ();
@@ -2546,7 +2546,7 @@ kill_command (char *arg, int from_tty)
 
   if (ptid_equal (inferior_ptid, null_ptid))
     error (_("The program is not being run."));
-  if (!query (_("Kill the program being debugged? ")))
+  if (!query (_("Kill the program being debugged?")))
     error (_("Not confirmed."));
   target_kill ();
 
@@ -2725,7 +2725,7 @@ attach_command (char *args, int from_tty)
     ;
   else if (target_has_execution)
     {
-      if (query (_("A program is being debugged already.  Kill it? ")))
+      if (query (_("A program is being debugged already.  Kill it?")))
 	target_kill ();
       else
 	error (_("Not killed."));
diff --git a/gdb/infrun.c b/gdb/infrun.c
index 917f9be..9ba852a 100644
--- a/gdb/infrun.c
+++ b/gdb/infrun.c
@@ -8386,7 +8386,7 @@ handle_command (char *args, int from_tty)
 	      if (!allsigs && !sigs[signum])
 		{
 		  if (query (_("%s is used by the debugger.\n\
-Are you sure you want to change it? "),
+Are you sure you want to change it?"),
 			     gdb_signal_to_name ((enum gdb_signal) signum)))
 		    {
 		      sigs[signum] = 1;
diff --git a/gdb/maint.c b/gdb/maint.c
index c95f645..63c37be 100644
--- a/gdb/maint.c
+++ b/gdb/maint.c
@@ -94,7 +94,7 @@ maintenance_command (char *args, int from_tty)
 static void
 maintenance_dump_me (char *args, int from_tty)
 {
-  if (query (_("Should GDB dump core? ")))
+  if (query (_("Should GDB dump core?")))
     {
 #ifdef __DJGPP__
       /* SIGQUIT by default is ignored, so use SIGABRT instead.  */
diff --git a/gdb/memattr.c b/gdb/memattr.c
index 40381c5..1e0547b 100644
--- a/gdb/memattr.c
+++ b/gdb/memattr.c
@@ -675,7 +675,7 @@ mem_delete_command (char *args, int from_tty)
 
   if (args == NULL || *args == '\0')
     {
-      if (query (_("Delete all memory regions? ")))
+      if (query (_("Delete all memory regions?")))
 	mem_clear ();
       dont_repeat ();
       return;
diff --git a/gdb/nto-procfs.c b/gdb/nto-procfs.c
index 6ab78e3..c6520b9 100644
--- a/gdb/nto-procfs.c
+++ b/gdb/nto-procfs.c
@@ -726,7 +726,7 @@ interrupt_query (void)
   target_terminal_ours ();
 
   if (query (_("Interrupted while waiting for the program.\n\
-Give up (and stop debugging it)? ")))
+Give up (and stop debugging it)?")))
     {
       target_mourn_inferior ();
       quit ();
diff --git a/gdb/printcmd.c b/gdb/printcmd.c
index 1744abd..cff9d3a 100644
--- a/gdb/printcmd.c
+++ b/gdb/printcmd.c
@@ -1654,7 +1654,7 @@ undisplay_command (char *args, int from_tty)
 {
   if (args == NULL)
     {
-      if (query (_("Delete all auto-display expressions? ")))
+      if (query (_("Delete all auto-display expressions?")))
 	clear_displays ();
       dont_repeat ();
       return;
diff --git a/gdb/procfs.c b/gdb/procfs.c
index 20afdee..2b88aa0 100644
--- a/gdb/procfs.c
+++ b/gdb/procfs.c
@@ -3179,7 +3179,7 @@ do_detach (int signo)
 
   if (signo || (proc_flags (pi) & (PR_STOPPED | PR_ISTOP)))
     if (signo || !(pi->was_stopped) ||
-	query (_("Was stopped when attached, make it runnable again? ")))
+	query (_("Was stopped when attached, make it runnable again?")))
       {
 	/* Clear any pending signal.  */
 	if (!proc_clear_current_fault (pi))
diff --git a/gdb/remote-mips.c b/gdb/remote-mips.c
index e519b22..b1eaeed 100644
--- a/gdb/remote-mips.c
+++ b/gdb/remote-mips.c
@@ -2286,7 +2286,7 @@ mips_kill (struct target_ops *ops)
       target_terminal_ours ();
 
       if (query (_("Interrupted while waiting for the program.\n\
-Give up (and stop debugging it)? ")))
+Give up (and stop debugging it)?")))
 	{
 	  /* Clean up in such a way that mips_close won't try to talk
 	     to the board (it almost surely won't work since we
diff --git a/gdb/remote.c b/gdb/remote.c
index fed397a..c51b7b2 100644
--- a/gdb/remote.c
+++ b/gdb/remote.c
@@ -1086,7 +1086,7 @@ set_memory_packet_size (char *args, struct memory_packet_config *config)
   if (fixed_p && !config->fixed_p)
     {
       if (! query (_("The target may not be able to correctly handle a %s\n"
-		   "of %ld bytes. Change the packet size? "),
+		   "of %ld bytes. Change the packet size?"),
 		   config->name, size))
 	error (_("Packet size not changed."));
     }
@@ -4631,7 +4631,7 @@ remote_open_1 (const char *name, int from_tty,
   if (rs->remote_desc != NULL && !have_inferiors ())
     {
       if (from_tty
-	  && !query (_("Already connected to a remote target.  Disconnect? ")))
+	  && !query (_("Already connected to a remote target.  Disconnect?")))
 	error (_("Still connected."));
     }
 
@@ -5607,7 +5607,7 @@ interrupt_query (void)
   if (rs->waiting_for_stop_reply && rs->ctrlc_pending_p)
     {
       if (query (_("The target is not responding to interrupt requests.\n"
-		   "Stop debugging it? ")))
+		   "Stop debugging it?")))
 	{
 	  remote_unpush_target ();
 	  throw_error (TARGET_CLOSE_ERROR, _("Disconnected from target."));
@@ -5616,7 +5616,7 @@ interrupt_query (void)
   else
     {
       if (query (_("Interrupted while waiting for the program.\n"
-		   "Give up waiting? ")))
+		   "Give up waiting?")))
 	quit ();
     }
 
diff --git a/gdb/reverse.c b/gdb/reverse.c
index ec8e4fc..0438f47 100644
--- a/gdb/reverse.c
+++ b/gdb/reverse.c
@@ -227,7 +227,7 @@ delete_bookmark_command (char *args, int from_tty)
 
   if (args == NULL || args[0] == '\0')
     {
-      if (from_tty && !query (_("Delete all bookmarks? ")))
+      if (from_tty && !query (_("Delete all bookmarks?")))
 	return;
       delete_all_bookmarks ();
       return;
diff --git a/gdb/skip.c b/gdb/skip.c
index a1cdd72..23c7912 100644
--- a/gdb/skip.c
+++ b/gdb/skip.c
@@ -91,7 +91,7 @@ skip_file_command (char *arg, int from_tty)
 	{
 	  fprintf_filtered (gdb_stderr, _("No source file named %s.\n"), arg);
 	  if (!nquery (_("\
-Ignore file pending future shared library load? ")))
+Ignore file pending future shared library load?")))
 	    return;
 	}
       /* Do not use SYMTAB's filename, later loaded shared libraries may match
@@ -137,7 +137,7 @@ skip_function_command (char *arg, int from_tty)
 			    _("No function found named %s.\n"), arg);
 
 	  if (nquery (_("\
-Ignore function pending future shared library load? ")))
+Ignore function pending future shared library load?")))
 	    {
 	      /* Add the unverified skiplist entry.  */
 	      skip_function (arg);
diff --git a/gdb/solib-svr4.c b/gdb/solib-svr4.c
index 2dc1692..1c71a97 100644
--- a/gdb/solib-svr4.c
+++ b/gdb/solib-svr4.c
@@ -1024,7 +1024,7 @@ open_symbol_file_object (void *from_ttyp)
   struct svr4_info *info = get_svr4_info ();
 
   if (symfile_objfile)
-    if (!query (_("Attempt to reload symbols from process? ")))
+    if (!query (_("Attempt to reload symbols from process?")))
       {
 	do_cleanups (cleanups);
 	return 0;
diff --git a/gdb/source.c b/gdb/source.c
index 194b044..3a9c69c 100644
--- a/gdb/source.c
+++ b/gdb/source.c
@@ -429,7 +429,7 @@ directory_command (char *dirname, int from_tty)
   /* FIXME, this goes to "delete dir"...  */
   if (dirname == 0)
     {
-      if (!from_tty || query (_("Reinitialize source path to empty? ")))
+      if (!from_tty || query (_("Reinitialize source path to empty?")))
 	{
 	  xfree (source_path);
 	  init_source_path ();
@@ -1936,7 +1936,7 @@ unset_substitute_path_command (char *args, int from_tty)
      is performed.  */
 
   if (from == NULL
-      && !query (_("Delete all source path substitution rules? ")))
+      && !query (_("Delete all source path substitution rules?")))
     error (_("Canceled"));
 
   /* Delete the rule matching the argument.  No argument means that
diff --git a/gdb/stack.c b/gdb/stack.c
index b825bdf..088d4aa 100644
--- a/gdb/stack.c
+++ b/gdb/stack.c
@@ -2450,13 +2450,13 @@ return_command (char *retval_exp, int from_tty)
       int confirmed;
 
       if (thisfun == NULL)
-	confirmed = query (_("%sMake selected stack frame return now? "),
+	confirmed = query (_("%sMake selected stack frame return now?"),
 			   query_prefix);
       else
 	{
 	  if (TYPE_NO_RETURN (thisfun->type))
 	    warning (_("Function does not return normally to caller."));
-	  confirmed = query (_("%sMake %s return now? "), query_prefix,
+	  confirmed = query (_("%sMake %s return now?"), query_prefix,
 			     SYMBOL_PRINT_NAME (thisfun));
 	}
       if (!confirmed)
diff --git a/gdb/symfile.c b/gdb/symfile.c
index 55a9f5c..6c4f77c 100644
--- a/gdb/symfile.c
+++ b/gdb/symfile.c
@@ -1165,7 +1165,7 @@ symbol_file_add_with_addrs (bfd *abfd, const char *name, int add_flags,
   if ((have_full_symbols () || have_partial_symbols ())
       && mainline
       && from_tty
-      && !query (_("Load new symbol table from \"%s\"? "), name))
+      && !query (_("Load new symbol table from \"%s\"?"), name))
     error (_("Not confirmed."));
 
   objfile = allocate_objfile (abfd, name,
@@ -1333,9 +1333,9 @@ symbol_file_clear (int from_tty)
   if ((have_full_symbols () || have_partial_symbols ())
       && from_tty
       && (symfile_objfile
-	  ? !query (_("Discard symbol table from `%s'? "),
+	  ? !query (_("Discard symbol table from `%s'?"),
 		    objfile_name (symfile_objfile))
-	  : !query (_("Discard symbol table? "))))
+	  : !query (_("Discard symbol table?"))))
     error (_("Not confirmed."));
 
   /* solib descriptors may have handles to objfiles.  Wipe them before their
@@ -2448,7 +2448,7 @@ remove_symbol_file_command (char *args, int from_tty)
     error (_("No symbol file found"));
 
   if (from_tty
-      && !query (_("Remove symbol table from file \"%s\"? "),
+      && !query (_("Remove symbol table from file \"%s\"?"),
 		 objfile_name (objf)))
     error (_("Not confirmed."));
 
diff --git a/gdb/target.c b/gdb/target.c
index 7ad2330..d8e4e2a 100644
--- a/gdb/target.c
+++ b/gdb/target.c
@@ -2180,7 +2180,7 @@ target_preopen (int from_tty)
     {
       if (!from_tty
 	  || !have_live_inferiors ()
-	  || query (_("A program is being debugged already.  Kill it? ")))
+	  || query (_("A program is being debugged already.  Kill it?")))
 	iterate_over_inferiors (dispose_inferior, NULL);
       else
 	error (_("Program not killed."));
diff --git a/gdb/top.c b/gdb/top.c
index d1e2271..e72e1c4 100644
--- a/gdb/top.c
+++ b/gdb/top.c
@@ -1509,7 +1509,7 @@ quit_confirm (void)
 
   fprintf_filtered (stb, _("A debugging session is active.\n\n"));
   iterate_over_inferiors (print_inferior_quit_action, stb);
-  fprintf_filtered (stb, _("\nQuit anyway? "));
+  fprintf_filtered (stb, _("\nQuit anyway?"));
 
   str = ui_file_xstrdup (stb, NULL);
   make_cleanup (xfree, str);
diff --git a/gdb/tracepoint.c b/gdb/tracepoint.c
index 6ca66e7..8e0af43 100644
--- a/gdb/tracepoint.c
+++ b/gdb/tracepoint.c
@@ -456,7 +456,7 @@ delete_trace_variable_command (char *args, int from_tty)
 
   if (args == NULL)
     {
-      if (query (_("Delete all trace state variables? ")))
+      if (query (_("Delete all trace state variables?")))
 	VEC_free (tsv_s, tvariables);
       dont_repeat ();
       observer_notify_tsv_deleted (NULL);
@@ -1911,7 +1911,7 @@ trace_start_command (char *args, int from_tty)
   if (current_trace_status ()->running)
     {
       if (from_tty
-	  && !query (_("A trace is running already.  Start a new run? ")))
+	  && !query (_("A trace is running already.  Start a new run?")))
 	error (_("New trace run not started."));
     }
 
@@ -2282,13 +2282,13 @@ query_if_trace_running (int from_tty)
       if (current_trace_status ()->disconnected_tracing)
 	{
 	  if (!query (_("Trace is running and will "
-			"continue after detach; detach anyway? ")))
+			"continue after detach; detach anyway?")))
 	    error (_("Not confirmed."));
 	}
       else
 	{
 	  if (!query (_("Trace is running but will "
-			"stop on detach; detach anyway? ")))
+			"stop on detach; detach anyway?")))
 	    error (_("Not confirmed."));
 	}
     }
diff --git a/gdb/utils.c b/gdb/utils.c
index 255aee8..b7f07be 100644
--- a/gdb/utils.c
+++ b/gdb/utils.c
@@ -727,7 +727,7 @@ internal_vproblem (struct internal_problem *problem,
       if (!confirm || !filtered_printing_initialized ())
 	quit_p = 1;
       else
-        quit_p = query (_("%s\nQuit this debugging session? "), reason);
+        quit_p = query (_("%s\nQuit this debugging session?"), reason);
     }
   else if (problem->should_quit == internal_problem_yes)
     quit_p = 1;
@@ -753,7 +753,7 @@ internal_vproblem (struct internal_problem *problem,
 	  /* Default (yes/batch case) is to dump core.  This leaves a GDB
 	     `dropping' so that it is easier to see that something went
 	     wrong in GDB.  */
-	  dump_core_p = query (_("%s\nCreate a core file of GDB? "), reason);
+	  dump_core_p = query (_("%s\nCreate a core file of GDB?"), reason);
 	}
     }
   else if (problem->should_dump_core == internal_problem_yes)
@@ -1258,7 +1258,7 @@ defaulted_query (const char *ctlstr, const char defchar, va_list args)
 
   /* Format the question outside of the loop, to avoid reusing args.  */
   question = xstrvprintf (ctlstr, args);
-  prompt = xstrprintf (_("%s%s(%s or %s) %s"),
+  prompt = xstrprintf (_("%s%s (%s or %s) %s"),
 		      annotation_level > 1 ? "\n\032\032pre-query\n" : "",
 		      question, y_string, n_string,
 		      annotation_level > 1 ? "\n\032\032query\n" : "");